//*****************************************************************************
//*
//*
//*		HttpDemo.cpp
//*
//*
//*****************************************************************************
#include	<string.h>
#include	<stdlib.h>
#include	<stdio.h>


#include	"HttpServer.h"
#include	"HttpIconPlugin.h"
#include	"HttpTreePlugin.h"
#include	"HttpFolderPlugin.h"
#include	"HttpScriptPlugin.h"
#include	"../HttpServer/System/System.h"




char	cMemory[] =
			"<p><b><font face=\"Verdana\" color=\"#0000FF\">Http Demo</font></b></p>\n"
			"<p><font face=\"Verdana\" size=\"2\">Memory.html</font></p>\n"
			"<hr>\n"
			"<p><font face=\"Verdana\" size=\"2\"><a href=\"index.html\">Back to index.html</a>.</font></p>\n"
			"<hr>\n"
			"<p><font face=\"Verdana\" size=\"1\">Copyright Anton Zechner (C) 2009</font></p>\n";

char	cCallback[] =
			"<p><b><font face=\"Verdana\" color=\"#0000FF\">Http Demo</font></b></p>\n"
			"<p><font face=\"Verdana\" size=\"2\">Callback.html</font></p>\n"
			"<hr>\n"
			"<p><font face=\"Verdana\" size=\"2\"><a href=\"index.html\">Back to index.html</a>.</font></p>\n"
			"<hr>\n"
			"<p><font face=\"Verdana\" size=\"1\">Copyright Anton Zechner (C) 2009</font></p>\n";

char	cCookieMem[1024];
char	cCookie[] =
			"<p><b><font face=\"Verdana\" color=\"#0000FF\">Http Demo</font></b></p>\n"
			"<p><font face=\"Verdana\" size=\"2\">Cookie.html : %s  (press reload to increase cookie)</font></p>\n"
			"<hr>\n"
			"<p><font face=\"Verdana\" size=\"2\"><a href=\"index.html\">Back to index.html</a>.</font></p>\n"
			"<hr>\n"
			"<p><font face=\"Verdana\" size=\"1\">Copyright Anton Zechner (C) 2009</font></p>\n";

char	cPostMem[1024];
char	cPost[] =
			"<p><b><font face=\"Verdana\" color=\"#0000FF\">Http Demo</font></b></p>\n"
			"<p><font face=\"Verdana\" size=\"2\">Post.html : \"%s\"</font></p>\n"
			"<hr>\n"
			"<p><font face=\"Verdana\" size=\"2\"><a href=\"index.html\">Back to index.html</a>.</font></p>\n"
			"<hr>\n"
			"<p><font face=\"Verdana\" size=\"1\">Copyright Anton Zechner (C) 2009</font></p>\n";

//*****************************************************************************
//*
//*		OnData
//*
//*****************************************************************************
//	Callback for data transmission
//	hConn		: handle from the connection
//	pBuffer		: buffer for the data
//	iSize		: size off the buffer in bytes
//	iOffset		: offset in the current transmission
//	Returns the count of copied bytes, 0 at the end, or -1 for an error.
int OnData(HttpConnection hConn,char *pBuffer,int iSize,int iOffset)
{
char   *pData;
int		iMax;
int		iNum;



	pData   = (char*)HttpGetUserPointer(hConn,0);
	iMax	=	     HttpGetUserValue  (hConn,1);


	if(iOffset>=iMax)return 0;

	iNum	= iMax-iOffset;

	if(iNum>iSize)iNum=iSize;


	memcpy(pBuffer,pData+iOffset,iNum);



return iNum;
}

//*****************************************************************************
//*
//*		OnPost
//*
//*****************************************************************************
//	Callback for a post input requests.
//	hConn		: handle from the connection
//	pBuffer		: buffer for the input data
//	iSize		: size off the input data in bytes
//	iOffset		: offset in the input transmission
//	Returns a http error code greater 99 or an action id:
//					HTTP_RESP_DEFAULT		0	use the default
//					HTTP_RESP_CALLBACK		1	use a callback for the response
//					HTTP_POST_DEFAULT		2	use the default post via internal memory
//					HTTP_POST_CALLBACK		3	use a post via callback
int OnPost(HttpConnection hConn,char *pBuffer,int iSize,int iOffset)
{
int		iLen;



	iLen = sprintf(cPostMem,cPost,pBuffer);


return HttpTransmitMemory(hConn,cPostMem,iLen);
}

//*****************************************************************************
//*
//*		OnConnect
//*
//*****************************************************************************
//	Callback for acceting a connection
//	hConn		: handle from the connection
//	pIpAddr		: ip address from the connecting client
//	usPort		: tcp port from the connecting client
//	Returns 1 if the connection will accepted, or 0 if not
int OnConnect(HttpConnection hConn,const char *pIpAddr,unsigned short usPort)
{

	printf("Connection accepted from %s:%hu\n",pIpAddr,usPort);


return 1;
}

//*****************************************************************************
//*
//*		OnDisconnect
//*
//*****************************************************************************
//	Callback for closing a connection
//	hConn		: handle from the connection
//	pIpAddr		: ip address from the connecting client
//	usPort		: tcp port from the connecting client
//	iReason		: is the reaon of the disconnection (see HTTP_MSG_???)
//	Returns 1 if the connection will accepted, or 0 if not
void OnDisconnect(HttpConnection hConn,const char *pIpAddr,unsigned short usPort,int iReason)
{

	printf("Connection to %s:%hu closed (reason=%i)\n",pIpAddr,usPort,iReason);

}

//*****************************************************************************
//*
//*		OnRequest
//*
//*****************************************************************************
//	Callback for a http request
//	hConn		: handle from the connection
//	iCommand	: is the commant of the request (see HTTP_CMD_???)
//	pHost		: is the host name of the request
//	pUrl		: is the path of the request
//	pParams		: are the parameters after the path
//	iUrlLen		: length of the path string
//	iParamLen	: length of the parameter string
//	Returns a http error code greater 99 or an action id:
//					HTTP_RESP_DEFAULT		0	use the default
//					HTTP_RESP_CALLBACK		1	use a callback for the response
//					HTTP_POST_DEFAULT		2	use the default post via internal memory
//					HTTP_POST_CALLBACK		3	use a post via callback
int OnRequest(HttpConnection hConn,int iCommand,const char *pHost,const char *pUrl,const char *pParams,int iUrlLen,int iParamLen)
{
char		cText[256];
char		cTemp[256];
const char *pValue;
const char *pCmd;
int			iVal;
int			iLen;


	switch(iCommand)
		{
	case HTTP_CMD_GET:		pCmd="GET";			break;
	case HTTP_CMD_HEAD:		pCmd="HEAD";		break;
	case HTTP_CMD_POST:		pCmd="POST";		break;
	case HTTP_CMD_PUT:		pCmd="PUT";			break;
	case HTTP_CMD_DELETE:	pCmd="DELETE";		break;
	case HTTP_CMD_TRACE:	pCmd="TRACE";		break;
	case HTTP_CMD_OPTIONS:	pCmd="OPTIONS";		break;
	case HTTP_CMD_CONNECT: 	pCmd="CONNECT";		break;
	case HTTP_CMD_LINK:	 	pCmd="LINK";		break;
	case HTTP_CMD_UNLINK:	pCmd="UNLINK";		break;
	default:				pCmd="Unknown";		break;
		}

	printf("%s request to %s%s %s\n",pCmd,pHost,pUrl,pParams);


	if(!strcmp(pUrl,"/Memory.html"))
		{
		return HttpTransmitMemory(hConn,cMemory,sizeof(cMemory));
		}

	if(!strcmp(pUrl,"/File.html"))
		{
		return HttpTransmitFile(hConn,"MyFile.html");
		}


	if(!strcmp(pUrl,"/Goto.html"))
		{
		return HttpTransmitGoto(hConn,"http://127.0.0.1/MyFile.html");
		}

	if(!strcmp(pUrl,"/Callback.html"))
		{
		HttpSetUserPointer(hConn,0,       cCallback );
		HttpSetUserValue  (hConn,1,sizeof(cCallback));
		return HttpTransmitCallback(hConn,OnData);
		}

	if(!strcmp(pUrl,"/Cookie.html"))
		{
		pValue = HttpGetCookie(hConn,"value");

		if(!pValue)
			{
			sprintf(cText,"no value cookie found");
			iVal = 1;
			}
		else{
			iVal = strtol(pValue,NULL,10);
			sprintf(cText,"value cookie is on %i",iVal);
			}

		sprintf(cTemp,"%i",iVal+1);
		HttpAddCookie(hConn,"value",cTemp);

		iLen = sprintf(cCookieMem,cCookie,cText);

		return HttpTransmitMemory(hConn,cCookieMem,iLen);
		}

	if(iCommand==HTTP_CMD_POST && !strcmp(pUrl,"/Post.html"))
		{
		HttpTransmitCallback(hConn,OnPost);
		return HTTP_POST_DEFAULT;
		}

	if(!memcmp(pUrl,"/Folder1/",9))
		{
		for(iLen=9;pUrl[iLen] && pUrl[iLen]!='/';iLen++);
		return HttpTransmitGoto(hConn,pUrl+iLen);
		}


return HTTP_RESP_DEFAULT;
}
	  
//*****************************************************************************
//*
//*		OnScript
//*
//*****************************************************************************
//	Callback for the script plug in 
//	hConn		: handle from the connection
//	pBuffer		: pointer to the output buffer
//	iSize		: size of the output buffer
//	pTag		: name of the requested tag ("*<name>" for a reacall) 
//	Returns the count of data bytes or -1 to stop the transmission.
//	If the HTTP_SCRIPT_RECALL flag is set the the tag will be called again.			
int _cdecl OnScript(HttpConnection hConn,char *pBuffer,int iSize,const char *pTag)
{

	if(!strcmp(pTag,"TAG1"))
		{
		strcpy(pBuffer,"this is tag 1");
		}
	else if(!strcmp(pTag,"TAG2"))
		{
		strcpy(pBuffer,"this is tag 2");
		}
	else{
		strcpy(pBuffer,"unknown tag");
		}


return strlen(pBuffer);
}
 
//*****************************************************************************
//*
//*		main
//*
//*****************************************************************************
int main(int argc, char* argv[])
{
HttpConfigData	sConfig;
HttpTreeHandle	hTree;
int				iTurn;
int				iErr;
int				iKey;



	memset(&sConfig,0,sizeof(sConfig));

    strcpy(sConfig.cIpAddress,"127.0.0.1");
	strcpy(sConfig.cFilePath,"./");
    sConfig.usTcpPort		= 80;					// is the tcp port for the server
	sConfig.iMaxConnections	= 32;					// maximum count of client connections
	sConfig.iPriority		= 128;					// taks priority 0-256
	sConfig.pCbConnect		= OnConnect;			// callback for client connection
	sConfig.pCbRequest		= OnRequest;			// callback for http requests
	sConfig.pCbDisconnect	= OnDisconnect;			// callback for client disconnection





	HttpTreeCreate("/Tree.html",&hTree,HTTP_TREE_EXPANDALL|HTTP_TREE_NOTREEURL);
	HttpTreeBackground(hTree,0xCCCCFF);
	HttpTreeAddEntry(hTree,"Folder1#MyFolder1",0);
	HttpTreeAddPath (hTree,"./",0,HTTP_TREE_SCANROOT|HTTP_TREE_ADDFOLDER|HTTP_TREE_EXPANDALL);



		   HttpRegisterScript(&sConfig,OnScript);
		   HttpRegisterFolder(&sConfig);
		   HttpRegisterTree  (&sConfig);
		   HttpRegisterIcon  (&sConfig);
	iErr = HttpDaemon        (&sConfig);

	switch(iErr)
		{
	case HTTP_ERR_NONE:			printf("http server started\n");			break;
	case HTTP_ERR_SOCKET:		printf("can't open server socket\n");		return 0;
	case HTTP_ERR_ISRUNNING:	printf("http server is running\n");			return 0;
	case HTTP_ERR_ISNOTRUNNING:	printf("http server is running\n");			return 0;
	case HTTP_ERR_WRONGPATH:	printf("the file path is wrong\n");			return 0;
	case HTTP_ERR_WRONGIP:		printf("the ip address is wrong\n");		return 0;
	case HTTP_ERR_INIT:			printf("initialization error\n");			return 0;
	case HTTP_ERR_NOTSTOPED:	printf("the server could not stopped\n");	return 0;
	default:					printf("unknown error\n");					return 0;
		}


	printf("\n\nInput \"http://127.0.0.1/index.html\" into your browser");
	printf("\n\nshutdown server with  ESC+ENTER \n\n\n");



	for(iTurn=0;iTurn<60*10;iTurn++)								// wait 10 minutes
		{
    	   iKey =getchar();
        if(iKey==27)break;
		if(iKey==10)break;
		}

	printf("shutdown server\n");

	HttpStopDaemon();



return 0;
}
