//*****************************************************************************
//*
//*
//*		HttpScriptPlugin.h
//*
//*
//*****************************************************************************
//
//	This plugin allows to load html script files (*.htmx).
//	Tags in the script ("@@<name>@@") files will be replaced
//	by data from a callback funktion.
//
#ifndef 	__HTTPSCRIPTPLUGIN_H__
#define 	__HTTPSCRIPTPLUGIN_H__

#include	"HttpServer.h"


#define 	HTTP_SCRIPT_RECALL		0x40000000			// recall for other data



#ifdef  __cplusplus
#define D(a)	a
extern "C" {
#else
#define D(a)	
#endif

typedef int  (_cdecl *HttpScriptCB)(HttpConnection hConn,char *pBuffer,int iSize,const char *pTag);

int			HttpInitScript      (					     HttpScriptCB pCbScript,int iUserId);
int			HttpRegisterScript	(HttpConfigData *pConfig,HttpScriptCB pCbScript,const char *pSuffix D(=0));
int  _cdecl	HttpScriptTrans     (HttpConnection  hConn  ,const char *pPath);

#ifdef  __cplusplus
}
#endif

#undef 	D

#endif



