//*****************************************************************************
//*
//*
//*		HttpTreePlugin.h
//*
//*
//*****************************************************************************
//
//	This plugin allows to show trees in a html side.
//
#ifndef 	__HTTPTREEPLUGIN_H__
#define 	__HTTPTREEPLUGIN_H__

#include	"HttpServer.h"


#ifdef  __cplusplus
#define D(a)	a
extern "C" {
#else
#define D(a)	
#endif

typedef		const char *HttpTreeHandle;


#define 	HTTP_TREE_CREATENEW			0x0010					// create new tree with url
#define 	HTTP_TREE_EXPANDALL			0x0020					// no folder view for the root path
#define 	HTTP_TREE_TYPESORT			0x0040					// sort file entries by type
#define 	HTTP_TREE_SCANROOT			0x0080					// insert files from the root folter too
#define 	HTTP_TREE_NOLINES			0x0100					// no lines in the tree
#define 	HTTP_TREE_NOSUFFIX			0x0200					// don't show file suffixes
#define 	HTTP_TREE_ADDFOLDER			0x0400					// add the scan path as folder
#define 	HTTP_TREE_NOFOLDERURL		0x0800					// don't insert href urls for folders
#define 	HTTP_TREE_NOROOTURL			0x1000					// don't insert href urls from the root
#define 	HTTP_TREE_NOTREEURL			0x2000					// don't insert the url of the tree
#define 	HTTP_TREE_ADDABOVE1			0x0001					// insert the scan 1 above
#define 	HTTP_TREE_ADDABOVE2			0x0002					// insert the scan 2 above
#define 	HTTP_TREE_ADDABOVE3			0x0003					// insert the scan 3 above
#define 	HTTP_TREE_ADDABOVE4			0x0004					// insert the scan 4 above
#define 	HTTP_TREE_ADDABOVE5			0x0005					// insert the scan 5 above
#define 	HTTP_TREE_ADDABOVE6			0x0006					// insert the scan 6 above
#define 	HTTP_TREE_ADDABOVE7			0x0007					// insert the scan 7 above
#define 	HTTP_TREE_ADDABOVEX			0x000F					// insert the scan mask
#define 	HTTP_TREE_ENTRY				0xFE00					// marker for entry insert

int			HttpRegisterTree	(HttpConfigData *pConfig);
void _cdecl HttpTreeDisconnect	(HttpConnection  hConn,const char *pIpAddr,unsigned short usPort,int iReason);
int  _cdecl	HttpTreeRequest		(HttpConnection  hConn,int   iCommand,const char *pHost,const char *pUrl,const char *pParams,int iUrlLen,int iParamLen);
int  _cdecl	HttpTreeData		(HttpConnection  hConn,char *pBuffer,int iSize,int iOffset);
int  _cdecl HttpTreeAddPath  	(HttpTreeHandle  hTree,const char *pPath,const char *pFilter D(=0),unsigned uFlags D(=0));
int  _cdecl HttpTreeAddEntry  	(HttpTreeHandle  hTree,const char *pName,int iMode D(=HTTP_TREE_ENTRY),const char *pUrl D(=0));
int  _cdecl HttpTreeBackground  (HttpTreeHandle  hTree,unsigned uColor,const char *pFile D(=0));
int  _cdecl HttpTreeSetUrlFrame (HttpTreeHandle  hTree,const char *pPrefix,const char *pSuffix D(=0));
int  _cdecl HttpTreeCreate  	(const char     *pUrl ,HttpTreeHandle *pHandle,unsigned uFlags D(=0));


#ifdef  __cplusplus
}
#endif

#undef 	D

#endif



